<?php
/**
 * @copyright	Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingAec extends JPlugin
{

	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'aec');
			$this->params = new acyParameter( $plugin->params );
		}
	}

 	function onAcyDisplayFilters(&$type,$context="massactions"){

		if($this->params->get('displayfilter_'.$context,true) == false) return;

		$db = JFactory::getDBO();
		$db->setQuery("SELECT `name`,`id` FROM #__acctexp_plans ORDER BY `ordering` ASC");
		$allGroups = $db->loadObjectList();
		if(empty($allGroups)) return;

		$firstGroup = new stdClass();
		$firstGroup->name = JText::_('ACY_ALL');
		$firstGroup->id = 0;
		array_unshift($allGroups,$firstGroup);

		$type['aec'] = 'AEC Subscription Manager';

		$inoperator = acymailing_get('type.operatorsin');
		$statusAEC = array();
		$statusAEC[] = JHTML::_('select.option', '',JText::_('ALL_STATUS'));
		$statusAEC[] = JHTML::_('select.option', 'Excluded','Excluded');
		$statusAEC[] = JHTML::_('select.option', 'Pending','Pending');
		$statusAEC[] = JHTML::_('select.option', 'Active','Active');
		$statusAEC[] = JHTML::_('select.option', 'Expired','Expired');
		$statusAEC[] = JHTML::_('select.option', 'Closed','Closed');
		$statusAEC[] = JHTML::_('select.option', 'Cancelled','Cancelled');
		$statusAEC[] = JHTML::_('select.option', 'Hold','Hold');

		$return = '<div id="filter__num__aec">';
		$return .= $inoperator->display("filter[__num__][aec][type]").' '.JHTML::_('select.genericlist',   $statusAEC, "filter[__num__][aec][status]", 'class="inputbox" size="1"').' '.JHTML::_('select.genericlist',   $allGroups, "filter[__num__][aec][plan]", 'class="inputbox" size="1"', 'id', 'name');
		$return .= '<br /><input type="text" name="filter[__num__][aec][signup_date_inf]" value="" onclick="displayDatePicker(this,event)"/> < '.JText::_('CREATED_DATE').' < <input type="text" name="filter[__num__][aec][signup_date_sup]" value="" onclick="displayDatePicker(this,event)" />';
		$return .= '<br /><input type="text" name="filter[__num__][aec][expiration_inf]" value="'.date('Y-m-d').'" onclick="displayDatePicker(this,event)" /> < '.JText::_('EXPIRY_DATE').' < <input type="text" name="filter[__num__][aec][expiration_sup]" value="" onclick="displayDatePicker(this,event)" />';

		$return .= '</div>';
		return $return;
	 }

	 function onAcyProcessFilter_aec(&$query,$filter,$num){
	 	$db = JFactory::getDBO();
	 	$lj = "`#__acctexp_subscr` as aec$num ON aec$num.`userid` = sub.`userid`";
	 	if(!empty($filter['plan'])) $lj .= " AND aec$num.`plan` = ".(int) $filter['plan'];
	 	if(!empty($filter['status'])) $lj .= " AND aec$num.`status` = ".$db->Quote($filter['status']);
	 	if(!empty($filter['signup_date_inf'])){
	 		$filter['signup_date_inf'] = acymailing_replaceDate($filter['signup_date_inf']);
	 		if(is_numeric($filter['signup_date_inf'])) $filter['signup_date_inf'] = date('Y-m-d H:i',$filter['signup_date_inf']);
	 		$lj .= " AND aec$num.`signup_date` > ".$db->Quote($filter['signup_date_inf']);
	 	}
	 	if(!empty($filter['signup_date_sup'])){
	 		$filter['signup_date_sup'] = acymailing_replaceDate($filter['signup_date_sup']);
	 		if(is_numeric($filter['signup_date_sup'])) $filter['signup_date_sup'] = date('Y-m-d H:i',$filter['signup_date_sup']);
	 		$lj .= " AND aec$num.`signup_date` < ".$db->Quote($filter['signup_date_sup']);
	 	}
	 	if(!empty($filter['expiration_inf'])){
	 		$filter['expiration_inf'] = acymailing_replaceDate($filter['expiration_inf']);
	 		if(is_numeric($filter['expiration_inf'])) $filter['expiration_inf'] = date('Y-m-d H:i',$filter['expiration_inf']);
	 		$lj .= " AND aec$num.`expiration` > ".$db->Quote($filter['expiration_inf']);
	 	}
	 	if(!empty($filter['expiration_sup'])){
	 		$filter['expiration_sup'] = acymailing_replaceDate($filter['expiration_sup']);
	 		if(is_numeric($filter['expiration_sup'])) $filter['expiration_sup'] = date('Y-m-d H:i',$filter['expiration_sup']);
	 		$lj .= " AND aec$num.`expiration` < ".$db->Quote($filter['expiration_sup']);
	 	}

	 	$query->leftjoin['aec_'.$num] = $lj;
	 	$query->where['member'] = 'sub.userid > 0';

	 	$operator = ($filter['type'] == 'IN') ? 'IS NOT NULL' : "IS NULL";
	 	$query->where[] = "aec$num.`userid` ".$operator;
	 }

}//endclass